<template>
  <v-container fluid fill-height>
    <v-layout align-center justify-center>
      <v-flex x12 sm6 md3>
        <v-card raised>
          <v-toolbar flat dark color="success">
            <v-icon>error</v-icon>
            <v-toolbar-title>Recovery wizard</v-toolbar-title>
            <v-spacer />
            <v-tooltip bottom>
              <v-btn icon slot="activator" @click="exit">
                <v-icon>clear</v-icon>
              </v-btn>
              <span>Exit recovery mode</span>
            </v-tooltip>
          </v-toolbar>

          <v-container fluid fill-height style="height:220px">
            <v-layout align-center justify-center>
              <v-progress-circular
                :size="150"
                :width="10"
                :value="progress"
                :indeterminate="waiting"
                color="success"
              >
                <v-layout align-center justify-center>
                  <v-icon size="60">{{ icon }}</v-icon>
                </v-layout>
              </v-progress-circular>
            </v-layout>
          </v-container>

          <v-card-text>
            <v-layout justify-center>
              <span class="text-xs-center" v-html="message"></span>
            </v-layout>

            <v-layout justify-center v-if="showButtons">
              <v-tooltip top>
                <v-checkbox
                  slot="activator"
                  label="Preserve User Data"
                  v-model="preserve.userdata"
                  hide-details
                  class="shrink mr-2"
                  color="success"
                ></v-checkbox>
                <span>
                  User data partition will not be formated
                  <br />in the recovery process.
                </span>
              </v-tooltip>

              <v-tooltip top>
                <v-checkbox
                  slot="activator"
                  label="Preserve System Data"
                  v-model="preserve.system"
                  hide-details
                  class="shrink mr-2"
                  color="success"
                ></v-checkbox>
                <span>
                  System data partition will not be formated
                  <br />in the recovery process.
                </span>
              </v-tooltip>
            </v-layout>
          </v-card-text>

          <v-layout justify-center v-if="showButtons">
            <v-card-actions>
              <v-btn flat @click="recover" color="success" :disabled="waiting"
                >Recover</v-btn
              >
            </v-card-actions>
          </v-layout>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
export default {
  data() {
    this.$store.commit("clearTimer");

    var preserve_system = true;
    var preserve_userdata = true;

    switch (this.$store.getters.suggested) {
      case "restore-bundles":
        break;
      case "lite-reinstall":
        preserve_system = false;
        break;
      case "full-reinstall":
        preserve_system = false;
        preserve_userdata = false;
        break;
    }

    return {
      preserve: {
        system: preserve_system,
        userdata: preserve_userdata
      }
    };
  },

  computed: {
    message() {
      switch (this.$store.getters.state) {
        case "welcome":
          return "Welcome to the Colibri-Linux recovery wizard. Depending on the system damage you can preserve some or all of our data.<br>To start press the <strong>RECOVER</strong> button below.";
        case "formatting":
          return "Formatting partitions for system re-installation...";
        case "copying":
          return "Copying system files...";
        case "finalizing":
          return "Finalizing system recovery...";
      }
      return "";
    },

    icon() {
      if (this.waiting) return "hourglass_empty";

      switch (this.$store.getters.state) {
        case "welcome":
          return "file_download";
        case "formatting":
          return "sd_storage";
        case "copying":
          return "insert_drive_file";
        case "finalizing":
          return "widgets";
        case "done":
          return "done";
      }
      return "sd_storage";
    },

    state() {
      return this.$store.getters.state;
    },

    showButtons() {
      return this.$store.getters.state == "welcome";
    },

    progress() {
      return this.$store.getters.progress;
    },

    waiting() {
      return this.$store.getters.waiting;
    }
  },

  methods: {
    exit() {
      this.$socket.send("do:boot");
    },

    recover() {
      var action = "do:boot";

      if (this.preserve.system && this.preserve.userdata) {
        action = "do:restore_bundles";
      } else if (!this.preserve.system && this.preserve.userdata) {
        action = "do:lite";
      } else if (this.preserve.system && !this.preserve.userdata) {
        action = "do:full";
      } else if (!this.preserve.system && !this.preserve.userdata) {
        action = "do:full";
      }
      this.$store.commit("setWaiting", true);
      this.$socket.send(action);
    }
  }
};
</script>

<style scoped></style>
